MODULE	'exec/lists',
			'exec/libraries',
			'exec/interrupts',
			'exec/tasks'

OBJECT ExecBase
	LibNode|Lib:Lib,
	SoftVer:UWORD,
	LowMemChkSum:WORD,
	ChkBase:ULONG,
	ColdCapture:APTR,
	CoolCapture:APTR,
	WarmCapture:APTR,
	SysStkUpper:APTR,
	SysStkLower:APTR,
	MaxLocMem:ULONG,
	DebugEntry:APTR,
	DebugData:APTR,
	AlertData:APTR,
	MaxExtMem:APTR,
	ChkSum:UWORD,
  IntVects[16]:IntVector,
	ThisTask:PTR TO TC,
	IdleCount:ULONG,
	DispCount:ULONG,
	Quantum:UWORD,
	Elapsed:UWORD,
	SysFlags:UWORD,
	IDNestCnt:BYTE,
	TDNestCnt:BYTE,
	AttnFlags:UWORD,
	AttnResched:UWORD,
	ResModules:APTR,
	TaskTrapCode:APTR,
	TaskExceptCode:APTR,
	TaskExitCode:APTR,
	TaskSigAlloc:ULONG,
	TaskTrapAlloc:UWORD,
	MemList:LH,
	ResourceList:LH,
	DeviceList:LH,
	IntrList:LH,
	LibList:LH,
	PortList:LH,
	TaskReady:LH,
	TaskWait:LH,
	SoftInts[5]:SH,
	LastAlert[4]:LONG,
	VBlankFrequency:UBYTE,
	PowerSupplyFrequency:UBYTE,
	SemaphoreList:LH,
	KickMemPtr:APTR,
	KickTagPtr:APTR,
	KickCheckSum:APTR,
	Pad0:UWORD,
	LaunchPoint:ULONG,
	RamLibPrivate:APTR,
	EClockFrequency:ULONG,
	CacheControl:ULONG,
	TaskID:ULONG,
	Reserved1[5]:ULONG,
	MMULock:APTR,
	Reserved2[3]:ULONG,
	MemHandlers:MLH,
	MemHandler:APTR

CONST	AFB_68010=0,
		AFB_68020=1,
		AFB_68030=2,
		AFB_68040=3,
		AFB_68881=4,
		AFB_68882=5,
		AFB_FPU40=6,
		AFB_FPU60=6,
		AFB_68060=7,                      // Definition for 68060 CPU
		AFB_PRIVATE=15,
		AFF_68010=1,
		AFF_68020=2,
		AFF_68030=4,
		AFF_68040=8,
		AFF_68881=16,
		AFF_68882=$20,
		AFF_FPU40=$40,
		AFF_FPU60=$40,
		AFF_68060=$80,                    // Definition for 68060 CPU
		AFF_PRIVATE=$8000,
		CACRF_EnableI=1,
		CACRF_FreezeI=2,
		CACRF_ClearI=8,
		CACRF_IBE=16,
		CACRF_EnableD=$100,
		CACRF_FreezeD=$200,
		CACRF_ClearD=$800,
		CACRF_DBE=$1000,
		CACRF_WriteAllocate=$2000,
		CACRF_EnableE=$40000000,
		CACRF_CopyBack=$80000000,
		DMAF_Continue=2,
		DMAF_NoModify=4,
		DMAF_ReadFromRAM=8
